Description

This is a guide on installing Redmine with PostgreSQL and nginx on FreeBSD 12.

Prepare the Environment

* Make sure everything is up to date using the following command:

pkg update -f && pkg upgrade

e |nstall dependencies:

pkg install portmaster

e Update ports tree:

portsnap fetch extract

e Create a redmine user:

pw add user -n redmine -m -s /sbin/nologin -c "Redmine"

Install PostgreSQL 12

e |nstall PostgreSQL:

pkg install postgresgll2-{server,client}

e Enable PostgreSQL at boot, initialize the database and start the service:

sysrc postgresqgl_enable=YES
service postgresqgl initdb
service postgresqgl start

e Switch to the pgsql user and enter into the psql prompt:

su postgres
psgl —-d templatel
o Create the redmineuser user and redminedb database:

CREATE ROLE redmineuser LOGIN ENCRYPTED PASSWORD 'SuperSecretPassword' NOINHERIT VALID UNT
IL 'infinity';
CREATE DATABASE redminedb WITH ENCODING='UTF8' OWNER=redmineuser;

e Exit from the postgres user

\q
exit

Install Nginx

e |nstall passenger binaries:
pkg install rubygem-passenger-nginx
e Compile nginx with passenger support:

portmaster www/nginx
o NOTE : Make sure to enable [X]PASSENGER while configuring nginx

® Add the redmine user to the www group:
pw usermod redmine -G www
e Start and enable nginx at boot:

sysrc nginx_enable=YES
service nginx start

e Create a configuration directory to make managing individual server blocks easier
mkdir /usr/local/etc/nginx/conf.d
e Edit the main nginx config file:

vi /usr/local/etc/nginx/nginx.conf

o And strip down the config file and add the include statement at the end to make it easier to handle various server blocks:
worker_processes 1;
error_log /var/log/nginx-error.log;
events {

worker_connections 1024;

http {
include mime.types;

default_type application/octet-stream;
sendfile on;

keepalive_timeout 65;

passenger_root /usr/local/lib/ruby/gems/2.7/gems/passenger;
passenger_ruby /usr/local/bin/ruby27;

# Load config files from the /etc/nginx/conf.d directory
include /usr/local/etc/nginx/conf.d/*.conf;

¢ Add a redmine.example.com server block:

vi /usr/local/etc/nginx/conf.d/redmine.example.com.conf

o Add the following:

server {
listen 80;
server_name redmine.example.com;
root /usr/local/www/redmine/public;
access_log /var/log/redmine.example.com-access.log;
error_log /var/log/redmine.example.com-error.log;

passenger_sticky_sessions on;
passenger_enabled on;
passenger_user redmine;
passenger_group redmine;

e Restart nginx:

service nginx restart

Install Redmine

e |nstall redmine:

pkg install redmine4

e Create the database.yml:

cp /usr/local/www/redmine/config/database.yml.example /usr/local/www/redmine/config/database.y
ml

e Edit the redmine database config:

vi /usr/local/www/redmine/config/database.yml

o And modify the production database settings:

production:
adapter: postgresqgl

database: redminedb

host: localhost

username: redmineuser

password: "SuperSecretPassword"
encoding: utf8

® |nstall gem dependencies:

cd /usr/local/www/redmine

su —-m redmine -c "bundle config without 'development test mysqgl'"
su -m redmine —-c "bundle config path 'vendor/bundle'"

su —m redmine -c "bundle install"

o NOTE: | had to run a bundle upgrade in order to get the bundle install to pass without issue.

e Generate a secret token:

su —m redmine -c "bundle exec rake generate_secret_token"

o Edit the Gemfile:

vi Gemfile

o And add the following below the other gem dependencies:

gem "pg", "n1.2.3"

o Create the database structure:

su —m redmine -c "env RAILS_ENV=production bundle exec rake db:migrate"

e Change the redmine site ownership:

chown -R redmine:www /usr/local/www/redmine

e Open a web browser and go to http:/redmine.example.com. The admin username is admin and password is admin.

Resources

¢ http://www.redmine.org/wiki/redmine/Redminelnstall
e http://www.redmine.org/wiki/redmine/RedmineUpgrade
¢ https://www.redmine.org/projects/redmine/wiki/redmineinstall#PostgreSQL

History

#1 - 02/11/2021 09:32 PM - Daniel Curtis

- Description updated

#2 - 02/11/2021 11:40 PM - Daniel Curtis
- Description updated

#3 - 02/12/2021 02:16 PM - Daniel Curtis
http://redmine.example.com
http://www.redmine.org/wiki/redmine/RedmineInstall
http://www.redmine.org/wiki/redmine/RedmineUpgrade
https://www.redmine.org/projects/redmine/wiki/redmineinstall#PostgreSQL

- Description updated

- Status changed from New to Resolved

#4 - 02/12/2021 02:17 PM - Daniel Curtis

- Description updated

#5 - 02/18/2022 08:08 PM - Daniel Curtis
- % Done changed from 0 to 100

- Status changed from Resolved to Closed
